package rocks.zipcode.quiz5.objectorientation.account;

/**
 * @author leon on 27/12/2018.
 */
public class BankAccount extends Account implements Transactable
{
    private double balance;

    public void setBalance(Double val) {
        balance = val;
    }

    @Override
    public void deposit(Double amountToIncreaseBy) {
        if (amountToIncreaseBy < 0.0){
            throw new java.lang.IllegalArgumentException();
        }
        else {
            balance += amountToIncreaseBy;
        }    }

    @Override
    public void withdrawal(Double amountToDecreaseBy) {
        if (amountToDecreaseBy < 0.0 || balance < amountToDecreaseBy){
            throw new java.lang.IllegalArgumentException();
        }
        else {
            balance -= amountToDecreaseBy;
        }
    }

    @Override
    public Double getBalance() {
        return balance;
    }
}
