package rocks.zipcode.quiz5.collections;
import java.util.HashMap;
import java.util.Map;

public class WordCounter
{
    Map<String, Integer> map = new HashMap<String, Integer>();
    String [] strings;

    public WordCounter(String... strings) {
        this.strings = strings;
    }

    public Map<String, Integer> getWordCountMap()
    {
       Map<String,Integer> map = new HashMap<>();
       for(String s : strings)
       {
           if(!map.containsKey(s))
           {
               map.put(s,1);
           }
           else
           {
               int count = map.get(s);
               map.put(s,count +1);
           }
       }
       return map;
    }
}
