package rocks.zipcode.quiz5.fundamentals;

import java.text.DecimalFormat;
import java.util.ArrayList;
import java.util.List;

/**
 * @author leon on 21/12/2018.
 */
public class Calculator {
    public static Double squareRoot(Double value) {
        double t;

        double squareRoot = value / 2;

        do {
            t = squareRoot;
            squareRoot = (t + (value / t)) / 2;
        } while ((t - squareRoot) != 0);

        return squareRoot;
    }

    public static Double square(Double value) {
        Double square = Math.pow(value, 2);
        return square;
    }

    public static Double[] squareRoots(Double... value)
    {
        Double[] result = new Double[value.length];
        for(int i = 0; i<value.length;i++)
        {
            result[i] = (Double) Math.sqrt(value[i]);
        }
        return result;
    }

    public static Double[] squares(Double... values) {
        Double[] result = new Double[values.length];
        for(int i = 0; i<values.length;i++)
        {
            result[i] = values[i]*values[i];
        }
        return result;
    }

    public static Double add(Double value1, Double value2) {
        return value1 + value2;
    }

    public static Double subtract(Double value1, Double value2) {
        return value1 - value2;
    }


    public static Double divide(Double divisor, Double dividend) {
        return divisor / dividend;
    }

}